-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.classes = {}
lib.classpreload = {}
lib.classpostload = {}


function lib.defaults()
	--cfg.xRes, cfg.yRes = string.match(({GetScreenResolutions()})[GetCurrentResolution()], "(%d+)x(%d+)")
	cfg.uiscale = UIParent:GetScale()
	cfg.aspectratio=GetMonitorAspectRatio()

	cfg.FindPriority=nil
	cfg.Update=nil

	cfg.target='normal'
	cfg.class = select(2,UnitClass("player"))
	
	cfg.Power={}
	cfg.Power.now=UnitPower("player")
	cfg.Power.type_num,cfg.Power.type=UnitPowerType("player")
	cfg.Power.max=UnitPowerMax("player")
	cfg.Power.regen = (select(2,GetPowerRegen()))
	cfg.Power.real=cfg.Power.now
	cfg.Power.local_type=_G[cfg.Power.type]
	cfg.Power.onpower=nil
	--cfg.Power.type_num=_G["SPELL_POWER_"..(select(2,UnitPowerType("player")))]
	
	cfg.AltPower={}
	cfg.AltPower.now=0
	cfg.AltPower.max=0
	cfg.AltPower.type_num=cfg.Power.type_num
	cfg.AltPower.func=nil
	cfg.AltPower.local_type=nil
	
	cfg.local_casttime=hedlib.BlizzPattern(_G["SPELL_CAST_TIME_SEC"])
	cfg.local_cd={}
	table.insert(cfg.local_cd,hedlib.BlizzPattern(_G["SPELL_RECAST_TIME_SEC"]))
	table.insert(cfg.local_cd,hedlib.BlizzPattern(_G["SPELL_RECAST_TIME_CHARGES_SEC"]))
	cfg.lastUpdate=0
	cfg.lastUpdateBar=0
	cfg.nextUpdate=0
	
	cfg.GUID={}
	cfg.GUID["player"] = UnitGUID("player") or 0
	cfg.GUID["pet"] = UnitGUID("pet") or 0
	cfg.GUID["target"] = UnitGUID("target") or 0 
	
	cfg.mounted=IsMounted()
	
	cfg.gcd=nil
	cfg.classfound=nil
	--cfg.now=GetTime()
	cfg.timeleft=0
	cfg.maxmintime = 21
	cfg.ctimeleft = cfg.maxmintime
	
	cfg.health={}
	cfg.health["target"]={}
	-- cfg.health["target"].max=UnitHealthMax("target") or 0
	-- cfg.health["target"].now=UnitHealth("target") or 0
	-- cfg.health["target"].percent=(cfg.health["target"].max==0) and 100 or hedlib.round(cfg.health["target"].now*100/cfg.health["target"].max,0)
	
	cfg.health["player"]={}
	-- cfg.health["player"].max=UnitHealthMax("target") or 0
	-- cfg.health["player"].now=UnitHealth("target") or 0
	-- cfg.health["player"].percent=(cfg.health["player"].max==0) and 100 or hedlib.round(cfg.health["player"].now*100/cfg.health["player"].max,0)
	
	cfg.nousecheck=false
	
	cfg.onupdate=nil
	cfg.onpower=nil
	cfg.onhealth=nil

	cfg.case = {}
	cfg.spells = {}
	cfg.spell_alias = {}
	cfg.spells_updating = {}
	cfg.sp_conv={}
	cfg.id2aura={}
	cfg.id2spell={}
	cfg.aura = {}
	cfg.aura_seen={}
	
	cfg.aura_unit_id = {}
	cfg.aura_found={}
	cfg.auras ={}
	cfg.plist = {}
	cfg.spellcast = {}
	cfg.lastspell_time=nil
	cfg.watchunits={}
	Heddevents = {}
	Heddclassevents = {}
	--cfg.combo = GetComboPoints('player', 'target')
	--cfg.holy = UnitPower("player" , SPELL_POWER_HOLY_POWER)
	cfg.mode=""
	cfg.set={}
	cfg.setitems={}
	cfg.equip={}
	cfg.trinket={}
	cfg.res_spells ={}
	cfg.haste=0
	cfg.res_spells ={
		[GetSpellInfo(75)]=true
		}
		
	cfg.Weapons={}
	cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()
	cfg.onGround = true
	cfg.spells_aoe={}
	cfg.spells_single={}
	cfg.spells_range={}
	
	cfg.heroism={[32182]=true,[2825]=true,[80353]=true,[90355]=true,[49016]=true,[178207]=true}
	
	
	cfg.TrackDOT={}
	cfg.TrackDOT.aura=nil
	cfg.TrackDOT.spell=nil
	cfg.TrackDOT.id=nil
	cfg.TrackDOT.targets={}
	cfg.TrackDOT.num=0
	cfg.TrackDOT.num_show=1
	cfg.TrackDOT.maxtick=3
	cfg.TrackDOT.Update=false
	cfg.TrackDOT.lastUpdate=0
	cfg.TrackDOT.func=nil
		
	cfg.TrackAura={}
	cfg.TrackAura.aura=nil
	cfg.TrackAura.max=0
	cfg.TrackAura.targets={}
	
	cfg.shape={}
	cfg.shape.name="human"
	cfg.shape.id=0 --GetShapeshiftFormID()
	cfg.shape.spellid=0 --select(5,GetShapeshiftFormInfo(GetShapeshiftForm()))
	cfg.cd_num=nil
	cfg.cd_last=nil
	cfg.CD={}
	cfg.cd_options=0
	cfg.dispell={}
	cfg.dispell["player"]={}
	cfg.dispell["player"].now=false
	cfg.dispell["player"].powerType={}
	cfg.dispell["player"].spell=nil
	cfg.dispell["target"]={}
	cfg.dispell["target"].now=false
	cfg.dispell["target"].powerType={}
	cfg.dispell["target"].spell=nil
	cfg.Interrupt={}
	cfg.Interrupt.spell=nil
	cfg.Interrupt.name=nil
	cfg.Interrupt.caststart=nil
	cfg.Interrupt.castend=nil
	cfg.Interrupt.iscasting=nil
	cfg.Interrupt.castid=nil
	cfg.Interrupt.id=nil
	cfg.Interrupt.notInterruptible=true
	
	
	cfg.talents={}
	
	cfg.Casting={}
	cfg.Casting.name=nil
	cfg.Casting.caststart=nil
	cfg.Casting.castend=nil
	cfg.Casting.iscasting=nil
	cfg.Casting.cost=0
	cfg.Casting.castid=nil
	cfg.Casting.id=nil
	
	cfg.fixspells={}
	cfg.fixspells_func={}
	cfg.fixspells_num=0
	
	cfg.pvp = UnitPlayerControlled("target")
	cfg.Range ={}
	cfg.RangeColor = {}
	--cfg.inRange = nil
	cfg.inRangeSpell="none"
end
lib.defaults()

cfg.shapes={}
cfg.shapes={
[1]="Cat",
[2]="Tree",
--[3]="Travel",
--[4]="Aquatic",
[5]="Bear",
--[16]="Spirit Wolf",
[17]="Battle",
[18]="Defensive",
[19]="Berserker",
[22]="Metamorphosis",
--[27]="Flight",
[28]="Shadow",
[30]="Stealth",
[31]="Moonkin"
}

cfg.HasDOTEvent = {}
cfg.HasDOTEvent = {
	["SPELL_AURA_APPLIED"]=true,
	["SPELL_AURA_REFRESH"]=true,
	["SPELL_PERIODIC_DAMAGE"]=true,
	["SPELL_PERIODIC_HEAL"]=true,
	["SPELL_PERIODIC_MISSED"]=true
	}

cfg.tagetlvl={
["minus"] = 0,
["normal"] = 1,
["rare"] = 2,
["elite"] = 2,
["rareelite"] = 2,
["worldboss"] = 3
}

cfg.power_class_spec = {
["WARLOCK"] = {
	[1] = "SOUL_SHARDS"
	}
}
--[[normal - Normal
	minus - Small
	rare - Rare
	elite - Elite
	rareelite - Rare-Elite
	worldboss - World Boss]]