-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib
--[[
Heddtalents - for talents change
Heddframe - Frameholder
Heddframe.move - for moving
Heddmain = Heddframe.main - Main frame
Heddmain.bar - timer
Heddmain.text - info
Heddmain.bd - backdrop
Heddmain.Aura - Monitor Main buff
Heddmain.DOT - Count dots
HeddCD = Heddframe.CD - CD frame
HeddTooltip = Heddframe.Tooltip - Tooltip frame
]]

Heddtalents = Heddtalents or CreateFrame("Frame","HEDD_tal",UIParent)
Heddtalents:Show()

Heddframe = Heddframe or CreateFrame("Button","HEDD_FRAME",UIParent)
Hedd = Heddframe
Heddframe:SetWidth(cfg.isize)
Heddframe:SetHeight(cfg.isize)
Heddframe:SetPoint(unpack(cfg.point))
Heddframe:SetMovable(true)
Heddframe:Show()
Heddframe:EnableMouse(true)

Heddframe.main=Heddframe.main or CreateFrame("Frame","HEDD_MAIN",Heddframe)
Heddmain=Heddframe.main
Heddmain:SetAllPoints(Heddframe)
Heddframe.move = Heddframe.move or CreateFrame("Frame","$parent_move",Heddmain)
Heddframe.move:SetAllPoints(Heddframe)
Heddframe.move:SetFrameStrata("MEDIUM")
Heddframe.move:SetFrameLevel(5)
hedlib.CreateTexture(Heddframe.move)
Heddframe.move.texture:SetColorTexture(135/255,206/255,235/255,0.5)
Heddframe.move:Hide()

hedlib.backdrop_texture=cfg.backdrop_texture
hedlib.backdrop_edge_texture=cfg.backdrop_edge_texture
hedlib.CreateBD(Heddmain,cfg.border,{1,0,0,1})
Heddmain.bd:Show()
Heddmain.bd:SetBackdropColor(0,0,0,0)
Heddmain.bd:SetBackdropBorderColor(0,0,0,0)
Heddmain.text = Heddmain.text or hedlib.CreateFont(Heddmain, cfg.textfont, cfg.tsize, "OUTLINE")
Heddmain.text:SetPoint("TOP",Heddmain,"BOTTOM")
Heddmain.text:SetText("")

--[[Heddmain.bar=Heddmain.bar or CreateFrame("StatusBar", "$parent_BAR", Heddmain)
Heddmain.bar:SetWidth(-1)
Heddmain.bar:SetHeight(cfg.bsize)
Heddmain.bar:SetStatusBarTexture(cfg.statusbar_texture)
Heddmain.bar:SetStatusBarColor(124/255, 252/255, 0)
Heddmain.bar.cd = 0
Heddmain.bar.start = GetTime()
Heddmain.bar:SetPoint("RIGHT",Heddmain,"LEFT")
Heddmain.bar.force=nil
Heddmain.bar.lu=GetTime()
Heddmain.bar.spell=nil
Heddmain.bar:Show()]]

Heddmain.bar=Heddmain.bar or CreateFrame("StatusBar", "$parent_BAR", Heddmain)
Heddmain.bar:SetWidth(cfg.scale*cfg.maxbar)
Heddmain.bar:SetHeight(cfg.bsize)
Heddmain.bar:SetStatusBarTexture(cfg.statusbar_texture)
Heddmain.bar:SetStatusBarColor(124/255, 252/255, 0)
Heddmain.bar:SetMinMaxValues(0, cfg.maxbar)
Heddmain.bar:SetReverseFill(true)
Heddmain.bar:SetValue(0)
Heddmain.bar.cd = 0
Heddmain.bar.start = GetTime()
Heddmain.bar:SetPoint("RIGHT",Heddmain,"LEFT")
Heddmain.bar.force=false
Heddmain.bar.lu=GetTime()
Heddmain.bar.spell=nil
Heddmain.bar:Show()

Heddmain.Aura = Heddmain.Aura or CreateFrame("Frame","$parent_BUFF",Heddmain)
Heddmain.Aura:SetWidth(cfg.isize)
Heddmain.Aura:SetHeight(cfg.isize)
Heddmain.Aura:SetPoint("LEFT",Heddmain,"RIGHT",10,0)
hedlib.CreateTexture(Heddmain.Aura)
hedlib.FrameAddCooldown(Heddmain.Aura)
Heddmain.Aura.text = Heddmain.Aura.text or hedlib.CreateFont(Heddmain.Aura, cfg.textfont, cfg.tsize, "OUTLINE")
Heddmain.Aura.text:SetPoint("BOTTOM",Heddmain.Aura,"TOP")
Heddmain.Aura.text:SetText("")
Heddmain.Aura:Hide()

Heddmain.DOT = Heddmain.DOT or CreateFrame("Frame","$parent_DOT",Heddmain)
Heddmain.DOT:SetWidth(cfg.isize)
Heddmain.DOT:SetHeight(cfg.isize)
Heddmain.DOT:SetPoint("LEFT",Heddmain.Aura,"RIGHT",10,0)
hedlib.CreateTexture(Heddmain.DOT)
hedlib.FrameAddCooldown(Heddmain.DOT)
Heddmain.DOT.text = Heddmain.DOT.text or hedlib.CreateFont(Heddmain.DOT, cfg.textfont, cfg.tsize, "OUTLINE")
Heddmain.DOT.text:SetPoint("BOTTOM",Heddmain.DOT,"TOP")
Heddmain.DOT.text:SetText("")
Heddmain.DOT.force=nil
Heddmain.DOT.stacks = Heddmain.DOT.stacks or hedlib.CreateFont(Heddmain.DOT, cfg.textfont, cfg.tsize, "OUTLINE","stacks")
Heddmain.DOT.stacks:SetPoint("TOP",Heddmain.DOT,"BOTTOM")
Heddmain.DOT.stacks:SetText("")
Heddmain.DOT:Hide()

Heddframe.CD = Heddframe.CD or CreateFrame("Frame","$parent_CD",Heddframe)
HeddCD=Heddframe.CD
HeddCD:SetWidth(cfg.cdsize)
HeddCD:SetHeight(cfg.cdsize)
HeddCD:SetPoint(unpack(cfg.point_cd))
hedlib.CreateTexture(HeddCD)
HeddCD.texture:SetColorTexture(135/255,206/255,235/255,0.5 )
HeddCD.texture:Hide()
HeddCD:SetMovable(true)
HeddCD:Show()

Heddframe.Tooltip = Heddframe.Tooltip or CreateFrame('GameTooltip', 'Hedd_Tooltip', UIParent, 'GameTooltipTemplate')
HeddTooltip = Heddframe.Tooltip
HeddTooltip:SetOwner(UIParent, 'ANCHOR_NONE')
HeddTooltip:Hide()